Subject: [bug#40373] [PATCH] guix: new command "guix run-script"

From: Konrad Hinsen <[email-masked]>
Date: Wed, 29 Apr 2020 18:04:40 +0200

Hi Simon,

> If I understand well
>      guix run-script file1 file2
> is becoming:
>     guix repl --script=file1,file2,...
> right?
>
> Well, I would say that
>
> --8<---------------cut here---------------start------------->8---
> the keyword "repl" stand for Read-Eval-Print-Loop
> therefore the command will:
>   - read the script file1,
>   - eval it,
>   - print the results if they are,
>   - and finally loop if there is more than one script file.
> --8<---------------cut here---------------end--------------->8---

That's very clever! The weak spot is the P, as script evaluation does
not print anything. We could make it print the script's return code ;-)

> But applying the same principles, the command
>     guix environment --ad-hoc python -- python
> could mystified the learner too, if for example they forgets --ad-hoc
> or '-- python'.

Indeed. I never said that existing Guix commands are perfect ;-)
In fact, I remember some debate about precisely the case of "guix
environment".

> And I still have in my stack how to propose another CLI naming as we
> discussed earlier, e.g.,
>     environment, package, etc.
> reorganized into
>   profile, install, search, etc.

The CLI as an eternal construction site ;-)

Cheers,
  Konrad